## ga 5.8.1

=== CMakeLists.txt ===
#
# module: CMakeLists.txt
# author: Bruce Palmer
# description: CMake build for GA. Only MPI-based runtimes are supported.
# 
# DISCLAIMER
#
# This material was prepared as an account of work sponsored by an
# agency of the United States Government.  Neither the United States
# Government nor the United States Department of Energy, nor Battelle,
# nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR
# ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
# COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
# SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
# INFRINGE PRIVATELY OWNED RIGHTS.
#
#
# ACKNOWLEDGMENT
#
# This software and its documentation were produced with United States
# Government support under Contract Number DE-AC06-76RLO-1830 awarded by
# the United States Department of Energy.  The United States Government
# retains a paid-up non-exclusive, irrevocable worldwide license to
# reproduce, prepare derivative works, perform publicly and display
# publicly by or for the US Government, including the right to
# distribute to other US Government contractors.
#
# -*- mode: cmake -*-
# -------------------------------------------------------------
# file: CMakeLists.txt
# -------------------------------------------------------------

cmake_minimum_required (VERSION 3.18.0 FATAL_ERROR)
project (GlobalArrays VERSION 5.8.0 LANGUAGES C)

# Append local CMake directory
list(INSERT CMAKE_MODULE_PATH 0 "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
list(INSERT CMAKE_MODULE_PATH 0 "${CMAKE_CURRENT_SOURCE_DIR}/cmake/linalg-modules")
message(STATUS "CMAKE_MODULE_PATH: ${CMAKE_MODULE_PATH}")
include(ga-utils)

ga_option(ENABLE_CXX ON)
ga_option(ENABLE_FORTRAN ON)
ga_option(CMAKE_CXX_EXTENSIONS OFF)

set(NOFORT 1)
set(ENABLE_F77 0)

if(ENABLE_CXX)
  enable_language(CXX)
endif()

if (ENABLE_FORTRAN)
  enable_language(Fortran)
  set(NOFORT 0)
  set(ENABLE_F77 1)
endif()

ga_option(CMAKE_BUILD_TYPE Release)
ga_option(LINALG_VENDOR BLIS)
ga_option(ENABLE_TESTS ON)
ga_option(ENABLE_PROFILING OFF)
#Options for user provided LinAlg libraries
ga_option(ENABLE_BLAS OFF)
ga_option(ENABLE_SCALAPACK OFF)
ga_option(ENABLE_EISPACK OFF)
ga_option(ENABLE_DPCPP OFF)
ga_option(ENABLE_DEV_MODE OFF)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CMAKE_NO_SYSTEM_FROM_IMPORTED ON)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
# set(CMAKE_LINK_DEPENDS_NO_SHARED ON)

include(${PROJECT_SOURCE_DIR}/cmake/ga-compiler-options.cmake)

if(ENABLE_BLAS)
  if(NOT ENABLE_FORTRAN)
    message(FATAL_ERROR "ENABLE_BLAS=ON needs ENABLE_FORTRAN=ON")
  endif()  
endif()

if(MSVC AND ENABLE_FORTRAN)
  message(FATAL_ERROR "MSVC build needs ENABLE_FORTRAN=OFF")
endif()

if(ENABLE_PROFILING)
  if(CMAKE_C_COMPILER_ID STREQUAL "Clang" OR CMAKE_C_COMPILER_ID STREQUAL "AppleClang")
    message(FATAL_ERROR "GA profiling is currently not supported with Clang compilers. Please set ENABLE_PROFILING=OFF")
  endif()
endif()

# GA Runtime options: MPI runtime used to build GA
ga_option(GA_RUNTIME MPI_2SIDED)

if (GA_RUNTIME STREQUAL MPI_PROGRESS_RANK)
  set (MPI_PR TRUE CACHE BOOL "use MPI progress ranks protocol for communication")
elseif (GA_RUNTIME STREQUAL MPI_RMA)
  set (MPI3 TRUE CACHE BOOL "use MPI RMA protocols for communication")
elseif (GA_RUNTIME STREQUAL MPI_MULTITHREADED)
  set (MPI_MT TRUE CACHE BOOL "use MPI multi-threading protocols for communication")
elseif (GA_RUNTIME STREQUAL MPI_PROGRESS_THREAD)
  set (MPI_PT TRUE CACHE BOOL "use MPI progress thread protocols for communication")
elseif (GA_RUNTIME STREQUAL MPI_2SIDED)
  set (MPI_TS TRUE CACHE BOOL "use MPI 2-sided protocol for communication")
else()
  message(STATUS "GA_RUNTIME provided \"${GA_RUNTIME}\" is not supported")
endif()

option (MSG_COMMS_MPI "Using MPI runtime for communication" ON)
option (ENABLE_ARMCI_MEM_OPTION "User option for managing memory" ON)
option (ENABLE_CUDA_MEM "User option for CUDA memory" OFF)
option (F2C_HIDDEN_STRING_LENGTH_AFTER_ARGS "Fortran/C interface property" ON)

message(STATUS "Checking MPI ...")
find_package (MPI REQUIRED)
set(GA_EXTRA_LIBS ${GA_EXTRA_LIBS} MPI::MPI_C)
if(ENABLE_FORTRAN)
  list(APPEND GA_EXTRA_LIBS MPI::MPI_Fortran)
endif()

include(${PROJECT_SOURCE_DIR}/cmake/ga-checks.cmake)

if (ENABLE_FORTRAN)
  include( FortranCInterface )
  FortranCInterface_HEADER(${CMAKE_CURRENT_BINARY_DIR}/f2c_cmake.h MACRO_NAMESPACE F77_FUNC_)
else()
  CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/cmake/f2c_dummy.h.in
                  ${CMAKE_CURRENT_BINARY_DIR}/f2c_cmake.h )
endif()

# set some flags for MS Visual C Compiler
if (MSVC)
  add_definitions(/D NOMINMAX /D _CRT_SECURE_NO_WARNINGS /D _CRT_NONSTDC_NO_WARNINGS)
endif()
   
# hardwire various GA configuration parameters. Use convention that parameters
# are defined and set to 0 if not used
set (CYGWIN 0)
set (DECOSF 0)

if (CMAKE_SYSTEM_NAME STREQUAL Linux)
  set(LINUX 1)
  set(LINUX64 1)
endif()

set(USE_I8 OFF)
if (CMAKE_SIZEOF_VOID_P EQUAL 8)
  set(USE_I8 ON)
  set(BLAS_SIZE 8)
endif()

option (ENABLE_I8 "Use 8 byte Fortran integers" ${USE_I8})
message(STATUS "void size: ${CMAKE_SIZEOF_VOID_P}, USE_I8: ${USE_I8}, ENABLE_I8: ${ENABLE_I8}")

include(${PROJECT_SOURCE_DIR}/cmake/ga-linalg.cmake)

# hardwire memcpy and strchr since these have been standard for years
set (HAVE_MEMCPY 1)
set (HAVE_STRCHR 1)

# miscellaneous hardwired parameters (mostly not used)
set (ENABLE_CHECKPOINT 0)
set (GA_PROFILING 0)
set (ENABLE_TRACE 0)
set (STATS 1)
set (USE_MALLOC 0)
if(ENABLE_PROFILING)
  set (GA_PROFILING 1)
endif()
if(USE_CRAYSHASTA)
  set(__CRAYXE 1)
  list(APPEND GA_EXTRA_LIBS pmi2)
endif()

# hardwire ARMCI configuration options
set (HAVE_ARMCI_GROUP_COMM 1)
set (HAVE_ARMCI_GROUP_COMM_MEMBER 0)
set (HAVE_ARMCI_INITIALIZED 1)

# suppress any checks to see if test codes run. Only check for compilation.
# use for cross-compilation situations
option (CHECK_COMPILATION_ONLY "Check compilation only" OFF)

if (ENABLE_FORTRAN)
  message(STATUS "CMAKE_Fortran_COMPILER: ${CMAKE_Fortran_COMPILER}")
  message(STATUS "CMAKE_Fortran_COMPILER_ID: ${CMAKE_Fortran_COMPILER_ID}")
  set (F90_MODULE )
  set (F77_GETARG GETARG)
  set (F77_GETARG_ARGS "i,s")
  set (F77_GETARG_DECLS "")
  set (F77_IARGC IARGC)
  set (F77_FLUSH flush)
  set (HAVE_F77_FLUSH 1)

  if (CMAKE_Fortran_COMPILER_ID MATCHES "GNU")
     message(STATUS "Using GNU Fortran compiler settings")
     set (F77_GETARG_DECLS "intrinsic GETARG")
     set (FORTRAN_I8_FLAG -fdefault-integer-8)
     set (FORTRAN_I4_FLAG "")
  elseif (CMAKE_Fortran_COMPILER_ID MATCHES "Flang")
     message(STATUS "Using Flang compiler settings")
     set (F77_GETARG_DECLS "external GETARG")
     set (FORTRAN_I8_FLAG -fdefault-integer-8)
     set (FORTRAN_I4_FLAG "")
  elseif (CMAKE_Fortran_COMPILER_ID MATCHES "Intel")
     message(STATUS "Using Intel Fortran compiler settings")
     set (F77_GETARG_DECLS "external GETARG")
     set (FORTRAN_I8_FLAG "-i8 -integer-size 64")
     set (FORTRAN_I4_FLAG "-i4 -integer-size 32")
  elseif (CMAKE_Fortran_COMPILER_ID MATCHES "PGI")
     message(STATUS "Using PGI Fortran compiler settings")
     set (FORTRAN_I8_FLAG -i8)
     set (FORTRAN_I4_FLAG -i4)
  elseif (CMAKE_Fortran_COMPILER_ID MATCHES "XL")
     message(STATUS "Using IBM XL Fortran compiler settings")
     set (FORTRAN_I8_FLAG -qintsize=8)
     set (FORTRAN_I4_FLAG -qintsize=4)
  endif()
else()
# need to set these variable even if only compiling C/C++
   set (F77_GETARG GETARG)
   set (F77_GETARG_ARGS "i,s")
   set (F77_GETARG_DECLS "external GETARG")
   set (F77_IARGC IARGC)
   set (FORTRAN_I8_FLAG -i8)
   set (FORTRAN_I4_FLAG -i4)
endif() 

# check_fortran_compiler_flag("-fallow-argument-mismatch" _fam)
# ga_is_valid(_fam _fam_flag_exists)
# if(_fam_flag_exists)
#   set (CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fallow-argument-mismatch")
# endif()
if(CMAKE_Fortran_COMPILER_ID STREQUAL "GNU" AND CMAKE_Fortran_COMPILER_VERSION VERSION_GREATER_EQUAL "10.1")
  set (CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fallow-argument-mismatch")
endif()

# Hardwire these settings. No way to check for Fortran integer size in CMake
# (that we can find)
set (CM_SIZEOF_F77_DOUBLE 8)
set (CM_SIZEOF_F77_REAL 4)
set (CM_SIZEOF_F77_INTEGER 4)
set (F2C_INTEGER_C_TYPE int)
set (F2C_REAL_C_TYPE float)
set (F2C_DOUBLE_PRECISION_C_TYPE double)
if (ENABLE_I8)
  set (CM_SIZEOF_F77_INTEGER 8)
  set (F2C_INTEGER_C_TYPE long)
  set (CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} ${FORTRAN_I8_FLAG}")
  message(STATUS "Fortran flags: ${CMAKE_Fortran_FLAGS}")
endif()
set (C_POINTER_AS_INTEGER int)
if (CMAKE_SIZEOF_VOID_P EQUAL 8)
  set (C_POINTER_AS_INTEGER long)
  if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
    set(NOUSE_MMAP 1)
  endif()
  set(GA_FORTRAN_ACCESS_INDEX integer*8)
else()
  set(GA_FORTRAN_ACCESS_INDEX integer*4)
endif()
# set (CM_BLAS_SIZE ${CM_SIZEOF_F77_INTEGER})

# -------------------------------------------------------------
# Create include files from templates
# -------------------------------------------------------------
CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/cmake/config.h.in
                ${CMAKE_CURRENT_BINARY_DIR}/config.h )
CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/cmake/farg.h.in
                ${CMAKE_CURRENT_BINARY_DIR}/gaf2c/farg.h )
CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/cmake/typesf2c.h.in
                ${CMAKE_CURRENT_BINARY_DIR}/gaf2c/typesf2c.h )
CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/cmake/matypes.h.in
                ${CMAKE_CURRENT_BINARY_DIR}/ma/matypes.h )
CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/cmake/mafdecls.fh.in
                ${CMAKE_CURRENT_BINARY_DIR}/ma/mafdecls.fh )
CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/cmake/global.fh.in
                ${CMAKE_CURRENT_BINARY_DIR}/global/src/global.fh )

if (ENABLE_FORTRAN)
  add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/config.fh
    COMMAND ${CMAKE_COMMAND} -D INPUT:PATH="${CMAKE_CURRENT_BINARY_DIR}/config.h" -D OUTPUT:PATH="${CMAKE_CURRENT_BINARY_DIR}/config.fh" -P ${PROJECT_SOURCE_DIR}/tools/config_fh_from_h.cmake DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/config.h
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/config.h
  )
  add_custom_target(
    GenerateConfigFH ALL
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/config.fh
  )
  set_source_files_properties(
    ${CMAKE_CURRENT_BINARY_DIR}/config.fh
    PROPERTIES GENERATED TRUE
  )
endif()

include_directories(AFTER ${MPI_INCLUDE_PATH})
add_definitions (-DHAVE_CONFIG_H -DOMPI_SKIP_MPICXX)

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)
list(APPEND GA_EXTRA_LIBS ${CMAKE_THREAD_LIBS_INIT})

if(NOT ENABLE_FORTRAN OR BUILD_SHARED_LIBS)
  if(NOT MSVC)
    list(APPEND GA_EXTRA_LIBS m)
  endif()
endif()
if(NOT "${CMAKE_HOST_SYSTEM_NAME}" STREQUAL "Darwin")
  if(NOT MSVC)
    list(APPEND GA_EXTRA_LIBS rt)
  endif()
endif()

if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
  add_compile_options(-fno-aggressive-loop-optimizations)
endif()

if(ENABLE_BLAS)
  list(APPEND GA_EXTRA_LIBS ${linalg_lib})
  add_compile_options(${BLAS_COMPILE_OPTIONS})
  add_compile_definitions(${BLAS_COMPILE_DEFINITIONS})
  #include_directories(${BLAS_INCLUDE_DIRS})
endif()

if(ENABLE_PROFILING)
  set(ga_profiler $<TARGET_OBJECTS:ga_tools>)
endif()

if(ENABLE_BLAS)
  include_directories(LinAlg/lapack+blas)
else()
  set(ga_ref_blas $<TARGET_OBJECTS:linalg>)
endif()

add_library(ga
  $<TARGET_OBJECTS:ma>
  $<TARGET_OBJECTS:dra>
  $<TARGET_OBJECTS:eaf>
  $<TARGET_OBJECTS:elio>
  $<TARGET_OBJECTS:sf>
  $<TARGET_OBJECTS:gaf2c>
  $<TARGET_OBJECTS:armci_comex>
  $<TARGET_OBJECTS:ga_src>
  ${ga_ref_blas}
  ${ga_profiler}
)
add_library(GlobalArrays::ga ALIAS ga)

set (CMAKE_REQUIRED_LIBRARIES lapack blas)
target_link_libraries(ga PUBLIC ${GA_EXTRA_LIBS})
target_include_directories(ga
  INTERFACE
    $<INSTALL_INTERFACE:include>
    $<INSTALL_INTERFACE:include/ga>
)
if(ENABLE_BLAS)
  target_include_directories(ga
    INTERFACE
      $<INSTALL_INTERFACE:${BLAS_INCLUDE_DIRS}>
  )
  target_compile_options(ga

=== ma/CMakeLists.txt ===
#
# module: CMakeLists.txt
# author: Bruce Palmer
# description: CMake build for GA. Only MPI-based runtimes are supported.
# 
# DISCLAIMER
#
# This material was prepared as an account of work sponsored by an
# agency of the United States Government.  Neither the United States
# Government nor the United States Department of Energy, nor Battelle,
# nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR
# ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
# COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
# SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
# INFRINGE PRIVATELY OWNED RIGHTS.
#
#
# ACKNOWLEDGMENT
#
# This software and its documentation were produced with United States
# Government support under Contract Number DE-AC06-76RLO-1830 awarded by
# the United States Department of Energy.  The United States Government
# retains a paid-up non-exclusive, irrevocable worldwide license to
# reproduce, prepare derivative works, perform publicly and display
# publicly by or for the US Government, including the right to
# distribute to other US Government contractors.
#
# -*- mode: cmake -*-
# -------------------------------------------------------------
# file: CMakeLists.txt
# -------------------------------------------------------------

include_directories(BEFORE ${CMAKE_CURRENT_SOURCE_DIR}
                    ${PROJECT_BINARY_DIR}/gaf2c
                    ${PROJECT_BINARY_DIR}/ma
                    ${PROJECT_BINARY_DIR}
)

# -------------------------------------------------------------
# MA header installation
# -------------------------------------------------------------

if (ENABLE_FORTRAN)
  set(FORTRAN_HEADERS maf2c.fh ${CMAKE_CURRENT_BINARY_DIR}/mafdecls.fh)
endif()

set(MA_HEADERS
  # ma.h
#  error.h
  macdecls.h
  macommon.h
#  memcpy.h
  # scope.h
  # string-util.h
  # table.h
  ${FORTRAN_HEADERS}
  ${CMAKE_CURRENT_BINARY_DIR}/matypes.h
)

install (FILES
  ${MA_HEADERS}
  DESTINATION include/ga
)

# -------------------------------------------------------------
# MA library installation
# -------------------------------------------------------------

if (ENABLE_FORTRAN)
  set(FORTRAN_FILES f2c.c maf.F)
endif()

add_library(ma OBJECT
  ma.c
  error.c
  string-util.c
  table.c
  ${FORTRAN_FILES}
)

if(ENABLE_FORTRAN)
  add_dependencies(ma gaf2c)
endif()

# -------------------------------------------------------------
# Build MA tests
# -------------------------------------------------------------

if(ENABLE_TESTS)

  if (ENABLE_FORTRAN)
    add_executable(testf.x testf.F)
  endif()
  add_executable(test-coalesce.x test-coalesce.c)
  add_executable(test-inquire.x test-inquire.c)
  #add_executable(testc.x testc.c)
  if (ENABLE_FORTRAN)
    target_link_libraries(testf.x ga)
  endif()
  target_link_libraries(test-coalesce.x ga)
  target_link_libraries(test-inquire.x ga)
  #target_link_libraries(testc.x ga)

endif()

=== debian/changelog ===
ga (5.8.1-5) unstable; urgency=medium

  * Team upload.
  * rebuild against scalapack 2.2

 -- Drew Parsons <dparsons@debian.org>  Mon, 07 Mar 2022 23:15:06 +0100

ga (5.8.1-4) unstable; urgency=medium

  * Team upload.
  * restore Build-Depends: libblas-dev. Linking against generic BLAS
    required to enable run-time execution against alternative
    optimized BLAS implementations (openblas, blis, atlas, etc)
  * likewise Build-Depends: liblapack-dev to link against generic LAPACK
    Install optimized library (openblas etc) for end-user execution.

 -- Drew Parsons <dparsons@debian.org>  Thu, 03 Mar 2022 11:57:46 +0100

ga (5.8.1-3) unstable; urgency=medium

  * Team upload.
  * install ga-config specific to each MPI flavour under /usr/lib
    and set /usr/bin/ga-config as a symlink to the default MPI.
  * update debian patch build_mpi_flavor.patch to apply MPI_FLAVOR to
    -lga and -larmci references in ga-config

 -- Drew Parsons <dparsons@debian.org>  Tue, 01 Mar 2022 23:08:18 +0100

ga (5.8.1-2) unstable; urgency=medium

  * Team upload.
  * build static libraries for both OpenMPI and MPICH
    - Build-Depends: libarmci-mpi-dev (>= 0.3.1~beta-2),
      libscalapack-openmpi-dev, libscalapack-mpich-dev,
      libopenmpi-dev, libmpich-dev
  * make MPI-specific build using MPI_FLAVOR as library name suffix
    (set with ./configure)
    - debian patch build_mpi_flavor.patch applies MPI_FLAVOR to
      automake files
    - build in subdir for each MPI flavor

 -- Drew Parsons <dparsons@debian.org>  Thu, 24 Feb 2022 13:16:05 +0100

ga (5.8.1-1) unstable; urgency=medium

  * Team upload.

  [ Drew Parsons ]
  * update debian/watch to watch releases/download links not tags
    (see https://github.com/GlobalArrays/ga/pull/240)
  * New upstream release.
  * provide a simple man page for ga-config (generated by help2man)
  * update debian/upstream/metadata to use Other-References not Homepage
    (see https://wiki.debian.org/UpstreamMetadata)
    Add Repository fields pointing to upstream github repo.
  * remove duplicate reference to armci/src/xfer/caccumulate.c in
    debian/copyright
  * Standards-Version: 4.6.0
  * debhelper compatibility level 13
    - mark uninstalled *.x and *.la files in debian/not-installed
  * configure with default path for armci to improve build
    reproducibility. Thanks Simon McVittie. Closes: #993674.

 -- Drew Parsons <dparsons@debian.org>  Sun, 13 Feb 2022 23:12:40 +0100

ga (5.8-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/fix_comex_testsuite.patch: Refreshed.
  * debian/patches/testsuite_log_compiler.patch: Likewise.
  * debian/copyright: Removed no longer needed sections.

 -- Michael Banck <mbanck@debian.org>  Sat, 01 Jan 2022 14:53:00 +0100

=== debian/control ===
Source: ga
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: debhelper-compat (= 13),
               gfortran,
               libarmci-mpi-dev (>= 0.3.1~beta-2),
               libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so,
               liblapack-dev | libopenblas-dev | libatlas-base-dev | liblapack.so,
               libscalapack-mpi-dev (>= 2),
               libscalapack-openmpi-dev (>= 2),
               libscalapack-mpich-dev (>= 2),
               mpi-default-dev,
               libopenmpi-dev, libmpich-dev,
               openssh-client
Standards-Version: 4.6.0
Homepage: http://hpc.pnl.gov/globalarrays/
Vcs-Browser: https://salsa.debian.org/debichem-team/ga
Vcs-Git: https://salsa.debian.org/debichem-team/ga.git

Package: libglobalarrays-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libga-dev (<< 5.4~beta~r10636+dfsg-3)
Breaks: libga-dev (<< 5.4~beta~r10636+dfsg-3)
Multi-Arch: no
Description: Distributed Shared-Memory Programming Environment (development)
 Global Arrays is a portable Non-Uniform Memory Access (NUMA) shared-memory
 programming environment for distributed and shared memory computers. It
 augments the message-passing model by providing a shared-memory like access to
 distributed dense arrays.
 .
 ARMCI provides one-sided remote memory operations used by GA.
 .
 ComEx (Communication Runtime for Extreme Scale) provides vector and strided
 interfaces to optimize performance of remote memory copy operations for
 non-contiguous data.  
 .
 DRA (Disk Resident Arrays) is a parallel I/O library that maintains dense 2-dim
 arrays on disk.
 .
 SF (Shared Files) is a parallel I/O library that allows noncollective I/O to a
 parallel file.
 .
 EAF (Exclusive Access Files) is parallel I/O library that supports I/O to
 private files.
 .
 TCGMSG is a simple, efficient, but becoming obsolete message-passing library.
 .
 TCGMSG-MPI is a TCGMSG interface implementation on top of MPI and ARMCI.
 .
 MA is a dynamic memory allocator/manager for Fortran and C programs.
 .
 GA++ is a C++ binding for global arrays.
 .
 This package contains the static libraries and header files.
 Static libraries are provided for both OpenMPI and MPICH.

=== debian/watch ===
version=4
 https://github.com/GlobalArrays/ga/releases \
 (?:.*?)/download/(?:.*?/)ga-@ANY_VERSION@@ARCHIVE_EXT@

## ga 5.8.2

=== comex/CMakeLists.txt ===
#
# module: CMakeLists.txt
# author: Bruce Palmer
# description: CMake build for GA. Only MPI-based runtimes are supported.
# 
# DISCLAIMER
#
# This material was prepared as an account of work sponsored by an
# agency of the United States Government.  Neither the United States
# Government nor the United States Department of Energy, nor Battelle,
# nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR
# ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
# COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
# SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
# INFRINGE PRIVATELY OWNED RIGHTS.
#
#
# ACKNOWLEDGMENT
#
# This software and its documentation were produced with United States
# Government support under Contract Number DE-AC06-76RLO-1830 awarded by
# the United States Department of Energy.  The United States Government
# retains a paid-up non-exclusive, irrevocable worldwide license to
# reproduce, prepare derivative works, perform publicly and display
# publicly by or for the US Government, including the right to
# distribute to other US Government contractors.
#
# -*- mode: cmake -*-
# -------------------------------------------------------------
# file: CMakeLists.txt
# -------------------------------------------------------------

option (COMEX_NETWORK_MPI_TS "use MPI 2-sided protocol for communication" OFF)
option (COMEX_NETWORK_MPI_PR "use MPI progress ranks protocol for communication" OFF)
option (COMEX_NETWORK_MPI3 "use MPI RMA protocols for communication" OFF)
option (COMEX_NETWORK_MPI_MT "use MPI multi-threading protocol for communication" OFF)
option (COMEX_NETWORK_MPI_PT "use MPI progress threads protocol for communication" OFF)

include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR} src-common)
if (MPI_TS)
  set(COMEX_DEVICE
    src-mpi/comex.c
    src-mpi/groups.c
  )
  set (COMEX_NETWORK_MPI_TS ON)
  include_directories(AFTER src-mpi)
elseif (MPI_PR)
  set(COMEX_DEVICE
    src-mpi-pr/comex.c
    src-mpi-pr/groups.c
    src-mpi-pr/reg_cache.c
  )
  set (COMEX_NETWORK_MPI_PR ON)
  include_directories(AFTER src-mpi-pr)
elseif (MPI3)
  set(COMEX_DEVICE
    src-mpi3/comex.c
    src-mpi3/groups.c
    src-mpi3/reg_win.c
  )
  set (COMEX_NETWORK_MPI3 ON)
  include_directories(AFTER src-mpi3)
elseif (MPI_MT)
  set(COMEX_DEVICE
    src-mpi-mt/comex.c
    src-mpi-mt/groups.c
  )
  set (COMEX_NETWORK_MPI_MT ON)
  include_directories(AFTER src-mpi-mt)
elseif (MPI_PT)
  set(COMEX_DEVICE
    src-mpi-pt/comex.c
    src-mpi-pt/groups.c
    src-mpi-pt/reg_cache.c
  )
  set (COMEX_NETWORK_MPI_PT ON)
  include_directories(AFTER src-mpi-pt)
endif()

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(comex-utils)

CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/cmake/config.h.in
                ${CMAKE_CURRENT_BINARY_DIR}/config.h )

# -------------------------------------------------------------
# ARMCI and COMEX header installation
# -------------------------------------------------------------

set(ARMCI_HEADERS
  src-armci/armci.h
  src-armci/message.h
  src-armci/parmci.h
)

set(COMEX_DEVICE_HEADERS
  src-common/comex.h
)

install (FILES
  ${ARMCI_HEADERS}
  ${COMEX_DEVICE_HEADERS}
  DESTINATION include/ga
)

# -------------------------------------------------------------
# ARMCI and COMEX library installation
# -------------------------------------------------------------

set(ARMCI_FILES
  src-armci/armci.c
  src-armci/capi.c
  src-armci/groups.c
  src-armci/iterator.c
  src-armci/message.c
)

add_library(armci_comex OBJECT
  ${ARMCI_FILES}
  ${COMEX_DEVICE}
)
target_compile_definitions(armci_comex PRIVATE HAVE_CONFIG_H)

add_library(armci
  ${ARMCI_FILES}
  ${COMEX_DEVICE}
)
target_compile_definitions(armci PRIVATE HAVE_CONFIG_H)

add_library(GlobalArrays::armci ALIAS armci)

target_link_libraries(armci)

install(TARGETS armci
    EXPORT globalarrays-targets
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

add_library(comex
 ${COMEX_DEVICE}
)

add_library(GlobalArrays::comex ALIAS comex)

target_link_libraries(comex)

install(TARGETS comex
    EXPORT globalarrays-targets
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

=== tools/CMakeLists.txt ===
#
# module: CMakeLists.txt
# author: Bruce Palmer
# description: CMake build for GA. Only MPI-based runtimes are supported.
# 
# DISCLAIMER
#
# This material was prepared as an account of work sponsored by an
# agency of the United States Government.  Neither the United States
# Government nor the United States Department of Energy, nor Battelle,
# nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR
# ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
# COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
# SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
# INFRINGE PRIVATELY OWNED RIGHTS.
#
#
# ACKNOWLEDGMENT
#
# This software and its documentation were produced with United States
# Government support under Contract Number DE-AC06-76RLO-1830 awarded by
# the United States Department of Energy.  The United States Government
# retains a paid-up non-exclusive, irrevocable worldwide license to
# reproduce, prepare derivative works, perform publicly and display
# publicly by or for the US Government, including the right to
# distribute to other US Government contractors.
#
# -*- mode: cmake -*-
# -------------------------------------------------------------
# file: CMakeLists.txt
# -------------------------------------------------------------

# -------------------------------------------------------------
# GA tools headers installation
# -------------------------------------------------------------

set(GA_TOOLS_HEADERS
  ${CMAKE_CURRENT_SOURCE_DIR}/ga-wprof.h
)

install(FILES
  ${GA_TOOLS_HEADERS}
  DESTINATION include/ga
)

add_library(ga_tools OBJECT
  ga-wapi.c
  ga-wprof.c
)


target_include_directories(ga_tools BEFORE PRIVATE
                    ${PROJECT_SOURCE_DIR}/ma
                    ${PROJECT_BINARY_DIR}/ma
                    ${PROJECT_BINARY_DIR}/gaf2c
                    ${PROJECT_BINARY_DIR}/global/src
                    ${PROJECT_SOURCE_DIR}/global/src
                    ${PROJECT_SOURCE_DIR}/comex/src-armci
                    ${PROJECT_BINARY_DIR})

=== debian/changelog ===
ga (5.8.2-3) unstable; urgency=medium

  * Team upload.
  * debian patch dsygv_int32_PR317.patch applies upstream PR#317 to
    ensure 32-bit integers are passed to dsygv. Needed in particular
    for big-endian architectures.

 -- Drew Parsons <dparsons@debian.org>  Sun, 05 Nov 2023 19:34:56 +0100

ga (5.8.2-2) unstable; urgency=medium

  * Team upload.
  * debian patch scalapack_32bit_PR315.patch applies upstream PR#315 to
    fix scalapack handling with 32 bit integers
  * Standards-Version: 4.6.2

 -- Drew Parsons <dparsons@debian.org>  Mon, 30 Oct 2023 00:55:44 +0100

ga (5.8.2-1) unstable; urgency=medium

  * Team upload.
  * update debian/watch to latest github format
  * New upstream release.
    - fixes tcgi pointer handling. Closes: #820677.
  * Standards-Version: 4.6.1

 -- Drew Parsons <dparsons@debian.org>  Wed, 23 Nov 2022 17:48:18 +0100

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
                mpi-default-dev,
                libopenmpi-dev, libmpich-dev,
                openssh-client
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Homepage: http://hpc.pnl.gov/globalarrays/
 Vcs-Browser: https://salsa.debian.org/debichem-team/ga
 Vcs-Git: https://salsa.debian.org/debichem-team/ga.git

=== debian/rules ===
#!/usr/bin/make -f

CFLAGS=-g -O2

export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

include /usr/share/mpi-default-dev/debian_defaults

%:
	dh $@ --with autoreconf

override_dh_clean:
	dh_clean
	rm -rf $(CURDIR)/pristine-src $(CURDIR)/build-mpich $(CURDIR)/build-openmpi

execute_after_dh_autoreconf:
	rm -rf $(CURDIR)/pristine-src $(CURDIR)/build-mpich $(CURDIR)/build-openmpi
	tmpdir=`mktemp -d`; \
	cp -ra $(CURDIR)/* $${tmpdir}; \
	mv $$tmpdir $(CURDIR)/pristine-src
	cp -ra pristine-src build-mpich
	cp -ra pristine-src build-openmpi

override_dh_auto_configure:
	for mpi_flavor in mpich openmpi; do \
		MPICC=mpicc.$${mpi_flavor} \
		MPICXX=mpicxx.$${mpi_flavor} \
		MPIF77=mpif77.$${mpi_flavor} \
		MPIFC=mpifort.$${mpi_flavor} \
		MPIF90=mpif90.$${mpi_flavor} \
		LDFLAGS="$${LDFLAGS} -pthread" \
		MPIEXEC="mpiexec.$${mpi_flavor} -np %NP%" \
		dh_auto_configure --sourcedirectory=$(CURDIR)/build-$${mpi_flavor} -- \
		--enable-cxx 				\
		--with-tcgmsg				\
		--with-scalapack="-lscalapack-$${mpi_flavor}" \
		--with-blas4=-lblas			\
		--with-lapack=-llapack			\
		--with-mpi				\
		--with-armci=-larmci-$${mpi_flavor}	\
		MPI_FLAVOR=$${mpi_flavor};		\
	done

override_dh_auto_build:
	for mpi_flavor in mpich openmpi; do \
	  dh_auto_build --sourcedirectory=$(CURDIR)/build-$${mpi_flavor}; \
	done

override_dh_auto_install:
	for mpi_flavor in mpich openmpi; do \
	  dh_auto_install --sourcedirectory=$(CURDIR)/build-$${mpi_flavor} --destdir=$(CURDIR)/debian/tmp; \
	done
	rm -f $(CURDIR)/debian/tmp/usr/include/error.h
	rm -f $(CURDIR)/debian/tmp/usr/include/memcpy.h
	rm -f $(CURDIR)/debian/tmp/usr/include/scope.h
	rm -f $(CURDIR)/debian/tmp/usr/include/string-util.h
	rm -f $(CURDIR)/debian/tmp/usr/include/table.h
	
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	-for mpi_flavor in mpich openmpi; do \
		dh_auto_test --sourcedirectory=$(CURDIR)/build-$${mpi_flavor} -- -j1 -k ARMCI_USE_WIN_ALLOCATE=1 MPIEXEC="mpiexec.$${mpi_flavor} -np 4"; \
	done
endif

override_dh_link:
	dh_link -plibglobalarrays-dev usr/lib/$(DEB_HOST_MULTIARCH)/libga-$(ARCH_DEFAULT_MPI_IMPL).a usr/lib/$(DEB_HOST_MULTIARCH)/libga.a
	dh_link -plibglobalarrays-dev usr/lib/$(DEB_HOST_MULTIARCH)/libga++-$(ARCH_DEFAULT_MPI_IMPL).a usr/lib/$(DEB_HOST_MULTIARCH)/libga++.a
	dh_link -plibglobalarrays-dev usr/lib/$(DEB_HOST_MULTIARCH)/ga/$(ARCH_DEFAULT_MPI_IMPL)/bin/ga-config  usr/bin/ga-config

## ga 5.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -41,6 +41,7 @@
 
 ga_option(ENABLE_CXX ON)
 ga_option(ENABLE_FORTRAN ON)
+ga_option(ENABLE_COVERAGE OFF)
 ga_option(CMAKE_CXX_EXTENSIONS OFF)
 
 set(NOFORT 1)
@@ -60,6 +61,7 @@
 ga_option(LINALG_VENDOR BLIS)
 ga_option(ENABLE_TESTS ON)
 ga_option(ENABLE_PROFILING OFF)
+ga_option(ENABLE_SYSV OFF)
 #Options for user provided LinAlg libraries
 ga_option(ENABLE_BLAS OFF)
 ga_option(ENABLE_SCALAPACK OFF)
@@ -80,8 +82,15 @@
   endif()  
 endif()
 
-if(MSVC AND ENABLE_FORTRAN)
-  message(FATAL_ERROR "MSVC build needs ENABLE_FORTRAN=OFF")
+if(ENABLE_FORTRAN)
+  if(MSVC)
+    message(FATAL_ERROR "MSVC build needs ENABLE_FORTRAN=OFF")
+  endif()
+
+  find_program(ga_m4_cmd NAMES gm4 m4)
+  if(NOT ga_m4_cmd)
+    message(FATAL_ERROR "m4 command not found. GNU M4 is required.")
+  endif()
 endif()
 
 if(ENABLE_PROFILING)
@@ -115,7 +124,23 @@
 message(STATUS "Checking MPI ...")
 find_package (MPI REQUIRED)
 set(GA_EXTRA_LIBS ${GA_EXTRA_LIBS} MPI::MPI_C)
+
+if(ENABLE_COVERAGE)
+  add_compile_options(--coverage)
+  list(APPEND GA_EXTRA_LIBS --coverage)
+endif()
+
 if(ENABLE_FORTRAN)
+  #macos fix for clang+gfortran build
+  #linking MPI::MPI_Fortran adds the flag to clang compile line
+  if (CMAKE_Fortran_COMPILER_ID MATCHES "GNU")
+    get_target_property(_mpif_ico MPI::MPI_Fortran INTERFACE_COMPILE_OPTIONS)
+    if(_mpif_ico)
+      string(REPLACE "-fallow-argument-mismatch" "" _mpif_ico ${_mpif_ico})
+      separate_arguments(_mpif_ico)
+      set_target_properties(MPI::MPI_Fortran PROPERTIES INTERFACE_COMPILE_OPTIONS "${_mpif_ico}")
+    endif()
+  endif()
   list(APPEND GA_EXTRA_LIBS MPI::MPI_Fortran)
 endif()
 
@@ -123,7 +148,20 @@
 
 if (ENABLE_FORTRAN)
   include( FortranCInterface )
-  FortranCInterface_HEADER(${CMAKE_CURRENT_BINARY_DIR}/f2c_cmake.h MACRO_NAMESPACE F77_FUNC_)
+  FortranCInterface_HEADER(${CMAKE_CURRENT_BINARY_DIR}/f2c_cmake.ignore MACRO_NAMESPACE F77_FUNC_)
+  add_custom_command(
+    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/f2c_cmake.h
+    COMMAND ${CMAKE_COMMAND} -D INPUT:PATH="${CMAKE_CURRENT_BINARY_DIR}/f2c_cmake.ignore" -D OUTPUT:PATH="${CMAKE_CURRENT_BINARY_DIR}/f2c_cmake.h" -P ${PROJECT_SOURCE_DIR}/tools/config_fh_from_h.cmake 
+    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/f2c_cmake.ignore
+  )
+  add_custom_target(
+    GenerateF2C_CH ALL
+    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/f2c_cmake.h
+  )
+  set_source_files_properties(
+    ${CMAKE_CURRENT_BINARY_DIR}/f2c_cmake.h
+    PROPERTIES GENERATED TRUE
+  )
 else()
   CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/cmake/f2c_dummy.h.in
                   ${CMAKE_CURRENT_BINARY_DIR}/f2c_cmake.h )
@@ -137,7 +175,6 @@
 # hardwire various GA configuration parameters. Use convention that parameters
 # are defined and set to 0 if not used
 set (CYGWIN 0)
-set (DECOSF 0)
 
 if (CMAKE_SYSTEM_NAME STREQUAL Linux)
   set(LINUX 1)
@@ -170,7 +207,7 @@
 endif()
 if(USE_CRAYSHASTA)
   set(__CRAYXE 1)
-  list(APPEND GA_EXTRA_LIBS pmi2)
+  # list(APPEND GA_EXTRA_LIBS pmi2)
 endif()
 
 # hardwire ARMCI configuration options
@@ -199,7 +236,7 @@
      set (FORTRAN_I8_FLAG -fdefault-integer-8)
      set (FORTRAN_I4_FLAG "")
   elseif (CMAKE_Fortran_COMPILER_ID MATCHES "Flang")
-     message(STATUS "Using Flang compiler settings")
+     message(STATUS "Using Flang compiler settings for flang, flang-new, armflang")
      set (F77_GETARG_DECLS "external GETARG")
      set (FORTRAN_I8_FLAG -fdefault-integer-8)
      set (FORTRAN_I4_FLAG "")
@@ -216,7 +253,15 @@
      message(STATUS "Using IBM XL Fortran compiler settings")
      set (FORTRAN_I8_FLAG -qintsize=8)
      set (FORTRAN_I4_FLAG -qintsize=4)
-  endif()
+  elseif (CMAKE_Fortran_COMPILER_ID MATCHES "Fujitsu")
+     message(STATUS "Fujitsu Fortran compiler settings")
+     set (FORTRAN_I8_FLAG "-CcdII8 -CcdLL8")
+     set (FORTRAN_I4_FLAG "")
+  elseif (CMAKE_Fortran_COMPILER_ID MATCHES "Cray")
+     message(STATUS "Cray Fortran compiler settings")
+     set (FORTRAN_I8_FLAG "-default64")
+     set (FORTRAN_I4_FLAG "")     
+  endif() 
 else()
 # need to set these variable even if only compiling C/C++
    set (F77_GETARG GETARG)
@@ -232,8 +277,25 @@
 # if(_fam_flag_exists)
 #   set (CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fallow-argument-mismatch")
 # endif()
-if(CMAKE_Fortran_COMPILER_ID STREQUAL "GNU" AND CMAKE_Fortran_COMPILER_VERSION VERSION_GREATER_EQUAL "10.1")
-  set (CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fallow-argument-mismatch")
+if(CMAKE_Fortran_COMPILER_ID STREQUAL "GNU")
+  if(CMAKE_Fortran_COMPILER_VERSION VERSION_GREATER_EQUAL "10.1")
+    set (CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fallow-argument-mismatch")
+  endif()
+  if(CMAKE_Fortran_COMPILER_VERSION VERSION_GREATER_EQUAL "11.1")
+    set (CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fno-tree-slp-vectorize")
+  endif()
+endif()
+
+if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
+  if(ENABLE_CXX) 
+    if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
+      add_compile_options(-fno-aggressive-loop-optimizations)
+    endif()
+  else()
+    add_compile_options(-fno-aggressive-loop-optimizations)
+  endif()  
+elseif (CMAKE_Fortran_COMPILER_ID STREQUAL "GNU")
+  set (CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fno-aggressive-loop-optimizations")
 endif()
 
 # Hardwire these settings. No way to check for Fortran integer size in CMake
@@ -256,9 +318,9 @@
   if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
     set(NOUSE_MMAP 1)
   endif()
-  set(GA_FORTRAN_ACCESS_INDEX integer*8)
+  set(GA_ACCESS_INDEX_TYPE integer*8)
 else()
-  set(GA_FORTRAN_ACCESS_INDEX integer*4)
+  set(GA_ACCESS_INDEX_TYPE integer*4)
 endif()
 # set (CM_BLAS_SIZE ${CM_SIZEOF_F77_INTEGER})
 
@@ -275,88 +337,3 @@
                 ${CMAKE_CURRENT_BINARY_DIR}/ma/matypes.h )
 CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/cmake/mafdecls.fh.in
                 ${CMAKE_CURRENT_BINARY_DIR}/ma/mafdecls.fh )
-CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/cmake/global.fh.in
-                ${CMAKE_CURRENT_BINARY_DIR}/global/src/global.fh )
-
-if (ENABLE_FORTRAN)
-  add_custom_command(
-    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/config.fh
-    COMMAND ${CMAKE_COMMAND} -D INPUT:PATH="${CMAKE_CURRENT_BINARY_DIR}/config.h" -D OUTPUT:PATH="${CMAKE_CURRENT_BINARY_DIR}/config.fh" -P ${PROJECT_SOURCE_DIR}/tools/config_fh_from_h.cmake DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/config.h
-    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/config.h
-  )
-  add_custom_target(
-    GenerateConfigFH ALL
-    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/config.fh
-  )
-  set_source_files_properties(
-    ${CMAKE_CURRENT_BINARY_DIR}/config.fh
-    PROPERTIES GENERATED TRUE
-  )
-endif()
-
-include_directories(AFTER ${MPI_INCLUDE_PATH})
-add_definitions (-DHAVE_CONFIG_H -DOMPI_SKIP_MPICXX)
-
-set(THREADS_PREFER_PTHREAD_FLAG ON)
-find_package(Threads REQUIRED)
-list(APPEND GA_EXTRA_LIBS ${CMAKE_THREAD_LIBS_INIT})
-
-if(NOT ENABLE_FORTRAN OR BUILD_SHARED_LIBS)
-  if(NOT MSVC)
-    list(APPEND GA_EXTRA_LIBS m)
-  endif()
-endif()
-if(NOT "${CMAKE_HOST_SYSTEM_NAME}" STREQUAL "Darwin")
-  if(NOT MSVC)
-    list(APPEND GA_EXTRA_LIBS rt)
-  endif()
-endif()
-
-if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
-  add_compile_options(-fno-aggressive-loop-optimizations)
-endif()
-
-if(ENABLE_BLAS)
-  list(APPEND GA_EXTRA_LIBS ${linalg_lib})
-  add_compile_options(${BLAS_COMPILE_OPTIONS})
-  add_compile_definitions(${BLAS_COMPILE_DEFINITIONS})
-  #include_directories(${BLAS_INCLUDE_DIRS})
-endif()
-
-if(ENABLE_PROFILING)
-  set(ga_profiler $<TARGET_OBJECTS:ga_tools>)
-endif()
-
-if(ENABLE_BLAS)
-  include_directories(LinAlg/lapack+blas)
-else()
-  set(ga_ref_blas $<TARGET_OBJECTS:linalg>)
-endif()
-
-add_library(ga
-  $<TARGET_OBJECTS:ma>
-  $<TARGET_OBJECTS:dra>
-  $<TARGET_OBJECTS:eaf>
-  $<TARGET_OBJECTS:elio>
-  $<TARGET_OBJECTS:sf>
-  $<TARGET_OBJECTS:gaf2c>
-  $<TARGET_OBJECTS:armci_comex>
-  $<TARGET_OBJECTS:ga_src>
-  ${ga_ref_blas}
-  ${ga_profiler}
-)
-add_library(GlobalArrays::ga ALIAS ga)
-
-set (CMAKE_REQUIRED_LIBRARIES lapack blas)
-target_link_libraries(ga PUBLIC ${GA_EXTRA_LIBS})
-target_include_directories(ga
-  INTERFACE
-    $<INSTALL_INTERFACE:include>
-    $<INSTALL_INTERFACE:include/ga>
-)
-if(ENABLE_BLAS)
-  target_include_directories(ga
-    INTERFACE
-      $<INSTALL_INTERFACE:${BLAS_INCLUDE_DIRS}>
-  )
-  target_compile_options(ga

=== debian/changelog ===
ga (5.9-2) unstable; urgency=medium

  * Team upload.
  * replace debian patch eaf_common_Integer.patch with
    hotfix_32bit_int.patch to apply upstream patches from hotfix/5.9.1
    branch fixing integers for 32-bit systems. See upstream Issue#352.

 -- Drew Parsons <dparsons@debian.org>  Thu, 20 Feb 2025 00:20:35 +0100

ga (5.9-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    - applies debian patches dsygv_int32_PR317.patch
      and scalapack_32bit_PR315.patch
  * update debian/copright to remove files removed upstream
  * update debian patch skip_failing_tests.patch to skip testsparse,
    which has incompatible definitions, see upstream Issue#361.
  * debian patch gcc15_gnu17_PR360.patch applies upstream PR#360
    to enable building with gcc-15 by specifying -std=gnu17.
    Closes: #1096668.
  * drop redundant debian patch fix_ga_target.patch

 -- Drew Parsons <dparsons@debian.org>  Wed, 19 Feb 2025 20:06:29 +0100

ga (5.8.2-11) unstable; urgency=medium

  * Team upload.
  * debian/patches/skip_failing_tests.patch: skip threadsafec
    on mips64el (times out with mpich)

 -- Drew Parsons <dparsons@debian.org>  Fri, 27 Sep 2024 02:55:51 +0200

ga (5.8.2-10) unstable; urgency=medium

  * Team upload.
  * debian/patches/skip_failing_tests.patch: skip thread_perf_strided
    on mips64el (times out with mpich)

 -- Drew Parsons <dparsons@debian.org>  Thu, 26 Sep 2024 17:15:49 +0200

ga (5.8.2-9) unstable; urgency=medium

  * Team upload.
  * debian/patches/skip_failing_tests.patch: skip thread_perf_contig
    on mips64el (times out with mpich)

 -- Drew Parsons <dparsons@debian.org>  Thu, 26 Sep 2024 09:14:54 +0200

ga (5.8.2-8) unstable; urgency=medium

  * Team upload.
  * debian/patches/skip_failing_tests.patch: skip the lennard-jones
    example on mips64el (times out with mpich)

 -- Drew Parsons <dparsons@debian.org>  Wed, 25 Sep 2024 16:50:19 +0200

ga (5.8.2-7) unstable; urgency=medium

  * Team upload.
  * debian patch skip_failing_tests.patch
    - skip jacobi on mips64el  mips64el times out (on mpich) after
      ghosts, jacobi is the next.
    - drop *_SOURCES for skipped tests

 -- Drew Parsons <dparsons@debian.org>  Tue, 24 Sep 2024 11:26:34 +0200

ga (5.8.2-6) unstable; urgency=medium

  * Team upload.
  * debian patch skip_failing_tests.patch skips tests which fail on
    the build environment. The tests pass when run manually.
    - mir_perf2, perfmod, perform, perf fail with "requires 4 GA processes"
      (but the tests are configured with -np 4)
    - sprsmatmult, stride have memory errors

 -- Drew Parsons <dparsons@debian.org>  Mon, 23 Sep 2024 16:00:30 +0200

ga (5.8.2-5) unstable; urgency=medium

  * Team upload.
  * debian/rules: run dh_auto_* build rules using --builddirectory not
    --sourcedirectory to get out-of-source builds
  * debian patch eaf_common_Integer.patch defines eaf handle and index
    using Integer rather than long for compatibility with MA.
    See upstream Issue#352.

 -- Drew Parsons <dparsons@debian.org>  Sat, 21 Sep 2024 19:20:42 +0200

ga (5.8.2-4) unstable; urgency=medium

  * Team upload.
  * only build against openmpi or mpich where supported by the arch.
    Prepare for openmpi 5 dropping 32-bit arch support.
    mpi-default-dev already declares that openmpi is not supported on
    32-bit arches.
  * Standards-Version: 4.7.0

 -- Drew Parsons <dparsons@debian.org>  Wed, 18 Sep 2024 16:22:07 +0200

=== debian/control ===
--- 
+++ 
@@ -9,12 +9,13 @@
                libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so,
                liblapack-dev | libopenblas-dev | libatlas-base-dev | liblapack.so,
                libscalapack-mpi-dev (>= 2),
-               libscalapack-openmpi-dev (>= 2),
+               libscalapack-openmpi-dev (>= 2) [!armel !armhf !i386 !hurd-i386 !hppa !m68k !powerpc !sh4 !x32],
                libscalapack-mpich-dev (>= 2),
                mpi-default-dev,
-               libopenmpi-dev, libmpich-dev,
+               libopenmpi-dev [!armel !armhf !i386 !hurd-i386 !hppa !m68k !powerpc !sh4 !x32],
+               libmpich-dev,
                openssh-client
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: http://hpc.pnl.gov/globalarrays/
 Vcs-Browser: https://salsa.debian.org/debichem-team/ga
 Vcs-Git: https://salsa.debian.org/debichem-team/ga.git

## ga 5.9.1

=== debian/changelog ===
ga (5.9.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    - applies debian patches gcc15_gnu17_PR360.patch
      and hotfix_32bit_int.patch

 -- Drew Parsons <dparsons@debian.org>  Thu, 20 Mar 2025 00:51:24 +0100
